import fetch from "flumm-fetch-cookies";

const apis = {
  launch: 'https://fdo.rocketlaunch.live/json/launches/next/1',
  fml: 'https://www.fmylife.com/random',
  konfuzius: 'https://de.wikiquote.org/w/api.php?action=parse&format=json&pageid=155&section=2',

};

const timeLeft = (s, t = []) => {
  for(let i = 0; i < 4; i++) {
    const d = [24, 60, 60, 1].slice(i).reduce((a, c) => a * c);
    const v = ~~(s / d);
    s -= v * d;
    t.push(v.toString().padStart(v ? 2 : 1, '0'));
  }
  return t.join(':');
};

export default async bot => {
  return [{
    name: "launch",
    call: /^\.nextrocket/i,
    set: "huan",
    f: async e => {
      let res;
      try {
        res = (await (await fetch(apis.launch)).json()).result[0];
      } catch(err) {
        console.error(err);
        return e.reply('Error contacting LaunchLibrary API');
      }
      const now = new Date();
      const launch_time = new Date(res.t0);
      const timedelta = Math.abs(launch_time - now);
      const t_string = timedelta > now ? "+" : "-";
      return e.reply(`Next rocket: ${res.vehicle.name} | ${res.name} | T${t_string}${timeLeft(timedelta / 1000)}`);
    }
  }, {
    name: "fml",
    call: /^\.fml/i,
    set: "huan",
    f: async e => {
      let res;
      try {
        res = await (await fetch(apis.fml)).text();
      } catch(err) {
        return e.reply('Error getting FML');
      }
      return e.reply(res.match(/<a href=\".*\" class=\"block.*\">\n(.*?)\n<\/a>/im)[1]);
    }
  }, {
    name: "konfuzius",
    call: /^\.konfuzius/i,
    set: "huan",
    f: async e => {
      let res;
      try {
        res = (await (await fetch(apis.konfuzius)).json()).parse.text['*'];
      } catch(err) {
        console.error(err);
      }

      const quotes = res
        .replace(/<a.+?>(.+?)<\/a>/g, '$1')
        .match(/<ul><li>\"(.*?)\" - <i>.*?<\/ul>/gm)
        .map(a => a.match(/\"(.*)\"/)[1]);

      return e.reply(`[b]Konfuzius sagt:[/b] ${quotes[~~(Math.random() * quotes.length)]}`);
    }
  }];
};
